implementation module Football

import Footballer, randomstream

instance zero Football where zero	= {ballPos=zero, ballSpeed=zero}

mkFootball :: !Position !Speed -> Football
mkFootball pos2D speed2D			= {ballPos = toPosition3D pos2D, ballSpeed = toSpeed3D speed2D}

ballIsFree :: !FootballState -> Bool
ballIsFree (Free _)					= True
ballIsFree _						= False

ballIsGainedBy :: !FootballerID !FootballState -> Bool
ballIsGainedBy id (GainedBy id`)	= id == id`
ballIsGainedBy _ _					= False

ballAtCenter :: !FootballField -> Football
ballAtCenter field					= {zero & ballPos={zero & pxy={px=field.flength/2.0,py=field.fwidth/2.0}}}

getFootball :: !FootballState !.[Footballer] -> Football
getFootball (Free ball) _			= ball
getFootball (GainedBy playerID) allPlayers
	= case filter (identify_player playerID) allPlayers of
		[]							= abort "getFootball: no player found with requested identifier."
		[{pos,speed}:_]				= mkFootball pos speed

ballGainedByKeeper :: !FootballState ![Footballer] !ClubName !Home !FootballField -> Bool
ballGainedByKeeper (Free _) _ _ _ _	= False
ballGainedByKeeper (GainedBy playerID) allPlayers club home field
	= case filter (identify_player playerID) allPlayers of
		[keeper]					= playerID.playerNr == 1 && inPenaltyArea field (if (playerID.clubName==club) home (other home)) keeper.pos
		wrong_number				= abort "ballGainedByKeeper: wrong number of keepers found."

bounceBall :: !BounceDirection !(!Speed3D,!RandomSeed) -> (!Speed3D,!RandomSeed)
bounceBall Up      (speed,seed)								= let (p,seed1) = nextRandomP seed in ({speed & vz = (10.0-speed.vz) * p},        seed1)
bounceBall Down    (speed,seed)								= let (p,seed1) = nextRandomP seed in ({speed & vz =       speed.vz  * p},        seed1)
bounceBall Forward (speed=:{vxy=sp2d=:{direction=d}},seed)	= let (p,seed1) = nextRandomP seed in ({speed & vxy = {sp2d & direction=d + p*pi/2.0 }},seed1)
bounceBall Back    (speed=:{vxy=sp2d=:{direction=d}},seed)	= let (p,seed1) = nextRandomP seed in ({speed & vxy = {sp2d & direction=d - p*pi/2.0 }},seed1)
