definition module guiInterface

import matchGame

/* Function description
	*	Parameters: !*Env
					FootballGame
	* 	Returns:	(Score,!*Env)			- the score at the end of the game
	* 	Description:Calculates an entire match and returns the endscore. 
					Usefull for quick calculating without the need to control the match itself
*/
computeEntireMatch		:: !FootballGame !*env -> (!Score,!*env) | FileSystem env


/*	True if the game has not finished
*/
timeLeft				:: !FootballGame -> Bool

/**	getSplashImageForGui loads the splash image for Soccer-Fun.
*/
getSplashImageForGui	:: !*env -> (!GamePicture,!*env) | FileSystem env

//	todo:
getActionPicsForGui		:: !Match !*env -> (!ActionPics,!*env) | FileSystem env

/*	Returns recommanded playing time
*/
defaultPlayingTime		:: PlayingTime

/*	Returns the default game for start
*/
acquireGame				:: !Match !ActionPics !*env -> (!FootballGame,!*env) | TimeEnv, FileSystem env

/*	Steps the game one step, returns the game and the referee events
*/
stepMatchForGui			:: !FootballGame !*env -> (![RefereeAction], !FootballGame, !*env) | FileSystem env

:: DisplaySpeed			= Slow | Target | Normal | Faster | Fastest
intervalFactor			:: !DisplaySpeed -> Real
