implementation module fileIO

import StdEnvExt
import StdBitmap

getImage :: !String !*env -> (!Bitmap,!*env) | FileSystem env
getImage path env
	= case openBitmap path env of
		(Nothing,_)			= abort ("getImage: unable to get Image " <+++ path <+++".\n")
		(Just bm,env)		= (bm,env)

writeFile :: !String !String !*env -> *env | FileSystem env
writeFile file text env
	# (open,outputFile,env)	= fopen file FAppendText env
	| not open				= abort ("writeFile: could not write text to " <+++ file <+++ ".\n")
	# (close, env)			= fclose (outputFile <<< text) env
	| not close				= abort ("writeFile: could not close " <+++ file <+++".\n")
	| otherwise				= env
